/************************************************************
File: 2_hostProgramMemory.sv
Name: Host Program memory
Description:
************************************************************/
module hostProgramMemory
		(	input	logic [$clog2(`m)-1:0]	hostProgAddr,
			input	logic [31:0]			hostProgram	,
			input	logic 					we			,
			output	logic [31:0]			instruction	,
			input	logic 					clock		);
	logic [31:0]	hPmem[0:`m-1];
	
	always_ff @(posedge clock) begin
	  if (we) hPmem[hostProgAddr] 	<= hostProgram			;
	  		  instruction 			<= hPmem[hostProgAddr]	;
	end
endmodule