	// in CONTROLLER
	function cSHR; // shift right one bit position
		cOpCode 	= `contr			;
		cOperand 	= `imm				;
		cScalar		= {`cshift, 19'b100};
	endfunction
	
	function cASHR; // shift right arithmetic one bit position
		cOpCode 	= `contr			;
		cOperand 	= `imm				;
		cScalar		= {`cshift, 19'b101};
	endfunction
	
	function cSHRC; // shift right one bit position with carry
		cOpCode 	= `contr			;
		cOperand 	= `imm				;
		cScalar		= {`cshift, 19'b110};
	endfunction
	
	function cSHL; // shift left one bit position
		cOpCode 	= `contr			;
		cOperand 	= `imm				;
		cScalar		= {`cshift, 19'b001};
	endfunction
	
	function cSHLC; // shift left one bit position with carry
		cOpCode 	= `contr			;
		cOperand 	= `imm				;
		cScalar		= {`cshift, 19'b010};
	endfunction
	
	function cROTR; // rotate right one bit position
		cOpCode 	= `contr			;
		cOperand 	= `imm				;
		cScalar		= {`cshift, 19'b111};
	endfunction
	
	function cROTL; // rotate right one bit position
		cOpCode 	= `contr			;
		cOperand 	= `imm				;
		cScalar		= {`cshift, 19'b011};
	endfunction
		
	// in ARRAY
	function SHR; // shift right one bit position
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`shift, 19'b100}	;
		endLineA						;
	endfunction
	
	function ASHR; // shift right arithmetic one bit position
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`shift, 19'b101} ;
		endLineA						;
	endfunction
	
	function SHRC; // shift right one bit position with carry
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`shift, 19'b110}	;
		endLineA						;
	endfunction
	
	function SHL; // shift left one bit position
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`shift, 19'b001}	;
		endLineA						;
	endfunction
	
	function SHLC; // shift left one bit position with carry
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`shift, 19'b010}	;
		endLineA						;
	endfunction
	
	function ROTR; // rotate right one bit position
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`shift, 19'b111}	;
		endLineA						;
	endfunction
	
	function ROTL; // rotate left one bit position
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`shift, 19'b011}	;
		endLineA						;
	endfunction