/************************************************************
File:
Name:
Description:
************************************************************/
`include "0_DEFINES.vh"
module aControl (	input	logic [`n+12:0]	instr		,
					input	logic [`n-1:0] 	aAcc		,
	                input	logic 			aCr			,
					output	logic 			boolean		,
					input	logic 			leftBool	,
					input	logic 			first		,
					input	logic 			next		,
					output	logic [1:0]		redFunc		,
					input	logic 			eq			,
					input	logic 			clock		);	
					
	logic [$clog2(`p)-1:0]	act		;
	logic [15:0]			cond	;
	logic [3:0]				condSel	;
 
	assign condSel = instr[3:0]	;
	assign boolean = act == 0	;
	assign cond = {	1'b0			,
					!(next || first),
					next	   		,
					first       	,
					leftBool      	,
					aAcc[`n-1]  	,
					aCr         	,
					(aAcc == 0)		,
					1'b1			,
					!(next || first),
					next	   		,
					first       	,
					leftBool      	,
					aAcc[`n-1]  	,
					aCr         	,
					(aAcc == 0) 	};				
					
	always_ff @(posedge clock) 
		case(instr[`n+7:`n])
			{`search,	`cim}:	act <= ((act == 0) && eq) ? act : act + 1		;
			{`search,	`imm}:	act <= ((act == 0) && eq) ? act : act + 1		;
			{`csearch, 	`cim}:	act <= (leftBool && eq) ? 0 : act + 1			;
			{`csearch, 	`imm}:	act <= (leftBool && eq) ? 0 : act + 1			;
			{`contr,	`imm}: 	case(instr[23:19])
									`allact	: act <= 0										;
									`where 	: act <= cond[condSel] ? act : act + 1			;
									`elsew 	: act <= (act == 0) ? 1 : ((act == 1) ? 0 : act);
									`back  	: act <= (act == 0) ? act : act - 1				;
									`selsh	: act <= leftBool ? 0 : 1						;
									`setred	: redFunc <= condSel[1:0]						;
									default	: begin act <= act								;
													redFunc <= redFunc 						;
											  end
								endcase
			default			: act <= act										;
		endcase	 	
endmodule