/************************************************************
File: 4_hostInMUX.sv
Name:
Description:
************************************************************/
module hostInMUX (	input	logic [1:0]		loadCom		,
					input	logic [31:0]	result		,
					input	logic [15:0]	value		,
					input	logic [31:0]	procDataIn	,
					input	logic [15:0]	leftOutLow	,
					output	logic [31:0]	muxOut		);
					
	always_comb case(loadCom)
					2'b00: muxOut = {{16{value[15]}}, value};
					2'b01: muxOut = {leftOutLow, value} 	;
					2'b10: muxOut = procDataIn				;
					2'b11: muxOut = result					;
				endcase					
endmodule