/************************************************************
File: 4_hostRegisterFile.sv
Name:
Description:
************************************************************/
module hostRegisterFile
		(	input	logic [31:0]	muxOut		,
			input	logic 			writeEnable	,	
			input	logic [4:0]		destAddr	,
			input	logic [4:0]		leftAddr	,
			input	logic [4:0]		rightAddr	,
			output	logic [31:0]	leftOut		,
			output	logic [31:0]	rightOut	,
			input					clock		);					
	logic [31:0]	hRegFile[0:31]	;
	
	always_ff @(posedge clock)	
		if (writeEnable) hRegFile[destAddr] <= muxOut	;		
	assign leftOut	= hRegFile[leftAddr	]	;	 	
	assign rightOut = hRegFile[rightAddr]	;				
endmodule