/************************************************************
File: 4_scan.sv
Name: Scan Network
Description:
************************************************************/
module scan (	input	logic [0:`p-1]	boolean	, 
				output	logic [0:`p-1]	first	,
				output	logic [0:`p-1]	next	,
				input	logic 			clock	);	
	logic [0:`p-1] out;
				
	orPrefix	orPrefix(	.in	(boolean),
							.out(out	));
	always_ff @(posedge clock) begin 
		first 	<= out & ~(out >> 1);
		next 	<= (out >> 1)		;
	end			
endmodule