/************************************************************
File:
Name:
Description:
************************************************************/
//`include "0_DEFINES.vh"
module distribute #(parameter P=`p)(	
		input	logic [`n+12:0]	contr2array			,			
		output	logic [`n+12:0]	fromDistr[0:P/4-1]	,       
		input	logic 			clock				);      

    logic [`n+12:0] out[0:1];
    
    genvar i;
    generate
     if (P/4 == 2) begin
        elDistribute elDis(	.in		(contr2array	),
							.out	(fromDistr[0:1]	),
							.clock	(clock			));
		end
      else  begin
        elDistribute elDis0(.in		(contr2array),
							.out	(out		),
							.clock	(clock		));           
		distribute #(.P(P/2))   			
			dis0(	.contr2array(out[0]      			),
					.fromDistr	(fromDistr[0:P/8-1]		),
					.clock  	(clock      			)),
            dis1(	.contr2array(out[1]       			),
					.fromDistr	(fromDistr[P/8:P/4-1]	),
					.clock  	(clock      			));
           end
    endgenerate
endmodule
							
