// in CONTROLLER
	// program run from value
	function cPRUN(input logic [18:0] value);
		cOpCode 	= `contr		;
		cOperand 	= `imm			;
		cScalar 	= {`prun, value};
	endfunction
	
	// program load starting from value 
	function cPLOAD(input logic [18:0] value);	
		cOpCode 	= `contr			;
		cOperand 	= `imm				;
		cScalar		= {`pload, value}	;
	endfunction
	
	// parameter load
	function cPARAM; 
		cOpCode 	= `contr			;
		cOperand 	= `imm				;
		cScalar		= {`param, 19'b0}	;
	endfunction
	
	// pop from inFIFO
	function cDATAINS(input logic [18:0] value);
		cOpCode 	= `contr			;
		cOperand 	= `imm				;
		cScalar		= {`datains, value}	;
	endfunction
	
	// push in outFIFO
	function cDATAEXT(input logic [18:0] value);
		cOpCode 	= `contr			;
		cOperand 	= `imm				;
		cScalar		= {`dataext, value}	;
	endfunction
	
	// set interrupt
	function cSETINT;  
		cOpCode 	= `contr			;
		cOperand 	= `imm				;
		cScalar		= {`setint, 19'b0}	;
	endfunction
	