// LOW LEVEL LIBRARY FUNCTIONS
/*
task PARAMETER; // send the parameter 'bigValue'
	input[31:0] bigValue	;
	begin 	
	{aOpCode, aOperand, aScalar, cOpCode, cOperand, cScalar} = bigValue	;
	endLine					;
	end
endtask

task GETM; // get matrix: get, starting at 'firstVect', 'lines' lines
	input[31:0] firstVect	;
	input[31:0] lines		;
	begin 	
	{aOpCode, aOperand, aScalar, cOpCode, cOperand, cScalar} = 
	{16'b0, prun, ctl, 8'b0000_0100}									;
	endLine																;
	{aOpCode, aOperand, aScalar, cOpCode, cOperand, cScalar} = firstVect;
	endLine					;
	{aOpCode, aOperand, aScalar, cOpCode, cOperand, cScalar} = lines	;
	endLine					;
	end
endtask

task SENDM; // send matrix: send, starting at 'firstVect', 'lines' lines
	input[31:0] firstVect	;
	input[31:0] lines		;
	begin 	
	{aOpCode, aOperand, aScalar, cOpCode, cOperand, cScalar} = 
	{16'b0, prun, ctl, 8'b0000_0101}									;
	endLine																;
	{aOpCode, aOperand, aScalar, cOpCode, cOperand, cScalar} = firstVect;
	endLine					;
	{aOpCode, aOperand, aScalar, cOpCode, cOperand, cScalar} = lines	;
	endLine					;
	end
endtask

task SQADD; // square matrix add
	input[31:0] dest	;
	input[31:0] first	;
	input[31:0] second	;
	begin 	
	{aOpCode, aOperand, aScalar, cOpCode, cOperand, cScalar} = 
	{16'b0, prun, ctl, 8'b0000_1011}									;
	endLine																;
	{aOpCode, aOperand, aScalar, cOpCode, cOperand, cScalar} = dest;
	endLine					;
	{aOpCode, aOperand, aScalar, cOpCode, cOperand, cScalar} = first	;
	endLine					;
	{aOpCode, aOperand, aScalar, cOpCode, cOperand, cScalar} = second	;
	endLine					;
	end
endtask

task SQMULT; // square matrix multuply
	input[31:0] dest	;
	input[31:0] first	;
	input[31:0] second	;
	begin 	
	{aOpCode, aOperand, aScalar, cOpCode, cOperand, cScalar} = 
	{16'b0, prun, ctl, 8'b0000_0110}									;
	endLine																;
	{aOpCode, aOperand, aScalar, cOpCode, cOperand, cScalar} = dest;
	endLine					;
	{aOpCode, aOperand, aScalar, cOpCode, cOperand, cScalar} = first	;
	endLine					;
	{aOpCode, aOperand, aScalar, cOpCode, cOperand, cScalar} = second	;
	endLine					;
	end
endtask

task SQMACC; // square matrix multuply & accumulate
	input[31:0] dest	;
	input[31:0] first	;
	input[31:0] second	;
	begin 	
	{aOpCode, aOperand, aScalar, cOpCode, cOperand, cScalar} = 
	{16'b0, prun, ctl, 8'b0000_0111}									;
	endLine																;
	{aOpCode, aOperand, aScalar, cOpCode, cOperand, cScalar} = dest;
	endLine					;
	{aOpCode, aOperand, aScalar, cOpCode, cOperand, cScalar} = first	;
	endLine					;
	{aOpCode, aOperand, aScalar, cOpCode, cOperand, cScalar} = second	;
	endLine					;
	end
endtask

task START; // start cycle counter
	begin 	
	{aOpCode, aOperand, aScalar, cOpCode, cOperand, cScalar} = 
	{16'b0, prun, ctl, 8'b0000_1000}									;
	endLine																;
	end
endtask

task STOP; // stop cycle counter
	begin 	
	{aOpCode, aOperand, aScalar, cOpCode, cOperand, cScalar} = 
	{16'b0, prun, ctl, 8'b0000_1001}									;
	endLine																;
	end
endtask

task INTRQ; // interrupt request
	begin 	
	{aOpCode, aOperand, aScalar, cOpCode, cOperand, cScalar} = 
	{16'b0, prun, ctl, 8'b0000_1010}									;
	endLine																;
	end
endtask
	//*/
	
	